<template>
  <transition
    :name="isInline ? '' : 'fade-dropdown'"
    @after-leave="doDestroy"
  >
    <div
      v-show="visible"
      ref="popper"
      :class="[ 'ob-dropdown__content', { 'is-inline': isInline }, `--${type} --${position} ${popperClass}` ]"
      :data-qa="dataQa"
    >
      <slot />
    </div>
  </transition>
</template>

<script>
import popperMixin from '../../mixins/Popper'
import { generateId } from '../../helpers/dom'

export default {
  name: 'SelectDropdown',
  mixins: [
    popperMixin
  ],
  props: {
    widthInherit: {
      type: Boolean,
      default: true
    },
    boundPadding: {
      type: Number,
      default: 0
    },
    openDelay: {
      type: Number,
      default: 0
    },
    position: {
      type: String,
      default: 'bottom-start'
    },
    popperClass: {
      type: String,
      default: ''
    },
    isInline: {
      type: Boolean,
      default: false
    },
    dataQa: {
      type: String
    }
  },
  inject: [
    'select'
  ],
  data () {
    return {
      transition: 'fade-dropdown',
      dropdownId: `ob-dropdown-${generateId()}`,
      localPopperOpt: {
        boundPadding: 0,
        inheritWidth: true
      }
    }
  },
  watch: {
    'select.isLoading' () {
      if (this.value) {
        this.updatePopper()
      }
    },
    'select.selectedValue' () {
      if (this.value) {
        this.updatePopper()
      }
    },
    'select.showAllItems' () {
      if (this.value) {
        this.updatePopper()
      }
    },
    'select.query' () {
      if (this.value) {
        this.updatePopper()
      }
    }
  },
  created () {
    this.localPopperOpt.inheritWidth = this.widthInherit
    this.localPopperOpt.boundPadding = this.boundPadding
  },
  mounted () {
    this.referenceElm = this.select.$refs['reference']
    this.$parent.popperElm = this.popperElm = this.$el
    if (this.value && this.popperVM) {
      this.popperVM.$nextTick(() => {
        if (this.value) {
          this.changeVisible(true)
        }
      })
    }
  }
}
</script>

<style lang="scss">
@import "../../static/css/variables";

.ob-dropdown {
  &__content {
    --ob-selector-padding: 20px;
    min-width: 150px;
    padding: 0;
    background: $background-white;
    border-radius: 2px;
    font-family: Roboto, sans-serif;
    font-style: normal;
    font-weight: normal;
    font-size: 12px;
    line-height: 16px;
    letter-spacing: 0.2px;
    color: $color-text-base;
    &:not(.is-inline) {
      z-index: 3900; // Header z-index is 4000, so need to place dropdown under it
      position: absolute;

      &.--primary {
        box-shadow: 0 4px 8px rgba($blue-700, 0.2);
      }
      &.--error {
        color: $color-error;
        box-shadow: 0 4px 8px rgba($color-error, 0.25);
      }
      &.--top {
        &.--primary {
          box-shadow: 0 -4px 8px rgba($color-blue-navy-blue, 0.25);
        }
        &.--error {
          box-shadow: 0 -4px 8px rgba($color-error, 0.25);
        }
      }

      &.--right {
        &.--primary {
          box-shadow: 4px 0 8px rgba($color-blue-navy-blue, 0.25);
        }
        &.--error {
          box-shadow: 4px 0 8px rgba($color-error, 0.25);
        }
      }

      &.--bottom {
        &.--primary {
          box-shadow: 0 4px 8px rgba($color-blue-navy-blue, 0.25);
        }
        &.--error {
          box-shadow: 0 4px 8px rgba($color-error, 0.25);
        }
      }

      &.--left {
        &.--primary {
          box-shadow: -4px 0 8px rgba($color-blue-navy-blue, 0.25);
        }
        &.--error {
          box-shadow: -4px 0 8px rgba($color-error, 0.25);
        }
      }
    }
  }
}

.fade-dropdown-enter-active, .fade-dropdown-leave-active {
  transition: opacity .3s;
}
.fade-dropdown-enter, .fade-dropdown-leave-to /* .fade-leave-active до версии 2.1.8 */ {
  opacity: 0;
}
</style>
